;************************************************************************
;*               Compare Bitmaps fast via asm with Threshold            *
;*                    This code is used from a VB Call                  *
;*                           by Daniel Aue 03.2004                      *
;*                                                                      *
;*                     USE ENTIRELY AT YOUR OWN RISK.                   *
;*                 you may publish this source as long as               *
;*                      this commentblock stays in                      *
;************************************************************************
      .386
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

    .code

pDataA      EQU <DWORD Ptr [ebp]>
pDataB      EQU <DWORD Ptr [ebp+4]>
Height      EQU <DWORD Ptr [ebp+8]>
picWidth    EQU <DWORD Ptr [ebp+12]>
ByteWidth   EQU <DWORD Ptr [ebp+16]>
Spotsize    EQU <DWORD Ptr [ebp+20]>
RGBThresh   EQU <DWORD Ptr [ebp+24]>
pCallback   EQU <DWORD Ptr [ebp+28]>
CurX        EQU <DWORD Ptr [ebp+32]>
CurY        EQU <DWORD Ptr [ebp+36]>
CSpotX      EQU <DWORD Ptr [ebp+40]>
CSpotY      EQU <DWORD Ptr [ebp+44]>
Result      EQU <DWORD Ptr [ebp+48]>
PadBytes    EQU <DWORD Ptr [ebp+52]>
Flags        EQU <DWORD Ptr [ebp+56]>

main:

            push    ebp
            mov     ebp,esp
            push    edi
            push    esi
            push    ebx

            mov     ebp,[ebp+8]     ;get Pointer to Parameter Struct

            mov     eax,picWidth
            mov     ebx,3
            mul     ebx
            mov     ebx,ByteWidth
            sub     ebx,eax
            mov     PadBytes,ebx
            
NextLine:
; Calc Y Spotsize for this Line: ------------------------
            mov eax,Height
            sub eax,CurY
            cmp eax,Spotsize
            jl @F
            mov eax,Spotsize
            @@:
            mov CSpotY,eax

NextSpotInLine:
; Calc X Spotsize for this Spot: ------------------------
            mov eax,picWidth
            sub eax,CurX
            cmp eax,Spotsize
            jl @F
            mov eax,Spotsize
            @@:
            mov CSpotX,eax

; Get RGB Mean for Data A ------------------------
            push CSpotY
            push CSpotX
            push pDataA
            call GetSpotMean
            push eax 

; Get RGB Mean for Data B ------------------------
            push CSpotY
            push CSpotX
            push pDataB
            call GetSpotMean
            pop ebx

; compare Blue ------------------------
            mov ecx,eax
            and ecx,255
            mov edx,ebx
            and edx,255
            sub ecx,edx
            
            cmp ecx,0
            jge  @F
            neg ecx
            @@:
            cmp ecx,RGBThresh
            ja Difference

; compare Green ------------------------
            mov ecx,eax
            shr ecx,8
            and ecx,255
            mov edx,ebx
            shr edx,8
            and edx,255
            sub ecx,edx
            
            cmp ecx,0
            jge  @F
            neg ecx
            @@:
            cmp ecx,RGBThresh
            ja Difference

; compare Red ------------------------
            mov ecx,eax
            shr ecx,16
            and ecx,255
            mov edx,ebx
            shr edx,16
            and edx,255
            sub ecx,edx
            
            cmp ecx,0
            jge  @F
            neg ecx
            @@:
            cmp ecx,RGBThresh
            ja Difference

            bt  Flags,0
            jc Callback  ;callback on equal spots -> do it now
            jmp NoCallback

Difference:
            add Result,1
            bt  Flags,0
            jc NoCallback  ;callback on equal spots ->don't do it

Callback:   ;  ------------------------
            cmp pCallback,0
            je  NoCallback
            push ebp
            push CSpotY
            push CSpotX
            mov  eax,Height
            sub  eax,CSpotY
            sub  eax,CurY
            push eax
            push CurX
            call pCallback
            pop ebp

NoCallback:
            mov eax,CSpotX
            add CurX,eax
            mov bx,3
            mul bx
            add pDataA,eax
            add pDataB,eax
            mov eax,picWidth
            cmp eax,CurX            
            jg  NextSpotInLine
            mov CurX,0

            mov eax,CSpotY
            add CurY,eax
            sub eax,1
            mul ByteWidth
            add eax,PadBytes
            add pDataA,eax
            add pDataB,eax
            mov eax,Height
            cmp eax,CurY
            jg  NextLine

            mov eax,Result

            pop ebx
            pop esi
            pop edi
            pop ebp
            ret 16

;*************************************************************************
GetSpotMean:

Tmp1        EQU <DWORD Ptr [esp+0]>
Tmp2        EQU <DWORD Ptr [esp+4]>
Tmp3        EQU <DWORD Ptr [esp+8]>
pData       EQU <DWORD Ptr [esp+16]>
XSize       EQU <DWORD Ptr [esp+20]>
YSize       EQU <DWORD Ptr [esp+24]>

        sub esp,12  ;reserve Tmp1-Tmp3
        
        mov eax,XSize
        mov ebx,3
        mul ebx
        mov ebx,ByteWidth
        sub ebx,eax

        xor eax,eax
        mov Tmp1,eax
        mov Tmp2,eax
        mov Tmp3,eax

        mov esi,pData
        mov edx,YSize
        

    Loop1:
        mov ecx,XSize
        @@:
            lodsb
            add Tmp1,eax
            lodsb
            add Tmp2,eax
            lodsb
            add Tmp3,eax
            dec ecx
            jne @b

        add esi,ebx
        dec edx
        jne Loop1

        mov eax,XSize
        mul YSize
        mov ebx,eax

        xor edx,edx
        mov eax,Tmp1
        div ebx
        mov Tmp1,eax

        xor edx,edx
        mov eax,Tmp2
        div ebx
        mov Tmp2,eax

        xor edx,edx
        mov eax,Tmp3
        div ebx
        mov Tmp3,eax

        mov eax,Tmp3
        shl eax,8
        or  eax,Tmp2
        shl eax,8
        or  eax,Tmp1

        add esp,12  ;free Tmp1-3
        ret 12
        
    
end main
